from handlers.PitcherPanelHandler import *
from handlers.ApiHandler import YgApiHandler
from handlers.GitHookHandler import *
from handlers.PublicAnalysisHandler import *
from handlers.TaskHandler import *
from handlers import OperateHandler
from handlers import AnalysisHandler

urls = [
    (r'/data/version', GetVersion),  # 获取版本号
    (r'/data/pitcher_panel/daily', PitcherPanelDaily),  # 投手日期汇总
    (r'/data/pitcher_panel/overview', PitcherPanelOverview),  # 投手今天概况
    (r'/data/channel_stat/overview', ChannelOverview),  # 公众号广告投放数据
    (r'/data/channel_stat/again_order_trend', ChannelAgainOrderTrend),  # 公众号复冲趋势
    (r'/data/channel_stat/active', ChannelActive),  # 公众号激活数据
    (r'/data/channel_stat/order_trend', ChannelOrderTrend),  # 公众号趋势
    (r'/data/channel_stat/channel', ChannelSummary),  # 公众号总数据
    (r'/data/pitcher/channel', ChannelPitcherSummary),  # 投手投放号
    (r'/data/pitcher/trend', PitcherTrend),  # 投手个人付费趋势

    # 公共分析
    (r'/data/book/rank', BookRank),  # 今日消耗排行
    (r'/data/book/trend', BookTrend),  # 小说付费趋势
    (r'/data/book/overview', BookOverview),  # 小说总数据
    (r'/data/pitcher/overview', PitcherOverview),  # 投手总数据

    (r'/data/image/rank', ImageRank),  # 图片消耗排行

    # 整体分析
    (r'/data/boss_panel/summary', BossPanelSummary),  # 整体概况图

    # 主动刷新任务
    (r'/task/src_book_info', SrcBookInfo),  # 刷新书籍卡点

    # 外部接口
    (r'/api/get_yangguang_data', YgApiHandler),  # 阳光订单回调接口

    # web hook
    (r'/api/git_hook/data_center', DataCenerHook),
    (r'/api/git_hook/qc_web', QcWebHook),

    # 广告排行榜
    (r'/data/advertisement/ad_rank', AdvertisementRank),  # 素材消耗排行

    # 广告素材库----创意
    (r'/data/advertisement/database/idea', AdvertisementIdea),

    # 广告素材库----图片
    (r'/data/advertisement/database/media', AdvertisementMedia),

    # 广告素材库----文本
    (r'/data/advertisement/database/content', AdvertisementContent),

    # 广告素材库----标签
    (r'/data/advertisement/database/label', AdvertisementRank),

    # 广告素材库----标签对应操作-----周一先标签全部无法操作,只能用现有
    (r'/data/advertisement/database/label/delete', AdvertisementRank),

    # 广告素材库----标签对应操作-----周一先标签全部无法操作,只能用现有
    (r'/data/advertisement/database/label/add', AdvertisementRank),

    # 广告收藏
    (r'/data/advertisement/database/collects', AdvertisementRank),

    # 广告素材标签罗列
    (r'/data/advertisement/database/label', AdvertisementRank),

    # 广告素材标签删除
    (r'/data/advertisement/database/label/delete', AdvertisementRank),

    # 广告素材标签添加
    (r'/data/advertisement/database/label/add', AdvertisementRank),

    # 广告素材标签修改
    (r'/data/advertisement/database/label/update', AdvertisementRank),

    # 广告收藏
    (r'/data/advertisement/database/collects', AdvertisementRank),
    # CRUD
    (r'/operate/channel_group.*', OperateHandler.ChannelGroupHandler),  # 公众号分组设置

    # 自助分析
    (r'/data/analysis.*', AnalysisHandler.ChannelAnalysisHandler),

]
